#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int N = 1e5;
int T[4*N];
int P[4*N];
int a[N];
vector<pair<pair<int, int>, pair<int, int>>> QR;
void build(int v, int tl, int tr){
    P[v] = 11;
    if(tr - tl == 1) {
        T[v] = a[v];
        return;
    }
    int tm = ((tr+tl)>>1);
    build((v<<1), tl, tm);
    build((v<<1)+1, tm, tr);
}
void push(int v){
    if(P[v]==11)
        return;
    P[(v<<1)] = P[(v<<1)+1] = P[v];
    T[(v<<1)] = T[(v<<1)+1] = P[v];
    P[v] = 11;
}
void upd(int v, int tl, int tr, int l, int r, int x){
    if(tr - tl > 1)
        push(v);
    if(tl >= r || tr <= l)
        return;
    if(tl >= l && tr <= r)
        P[v] = T[v] = x;
    if(tr - tl == 1){
        T[v] = x;
    }
    int tm = ((tr + tl)>>1);
    upd((v<<1), tl, tm, l, r, x);
    upd((v<<1) + 1, tm, tr, l, r, x);
}

int get(int v, int tl, int tr, int id){
    if(tr - tl > 1)
        push(v);
    if(tr - tl == 1){
        return T[v];
    }
    int tm = ((tr + tl)>>1);
    if(id < tm)
        return get((v<<1), tl, tm, id);
    else
        return get((v<<1)+1, tm, tr, id);
}
vector<pair<int, int>> g;
vector<int> e;
void dfs(int v){
    if(v==-1)
        return;
    if(g[v].first==g[v].second) {
        e.push_back(v);
        return;
    }
   if(a[v] == -1)
       e.push_back(v);
    dfs(g[v].first);
    if(a[v] == 0)
        e.push_back(v);
    dfs(g[v].second);
    if(a[v] == 1)
        e.push_back(v);
}
void solve1(int q, int S){
    for(int j = 0; j < q; j++){
        int t;
        t=QR[j].first.first;
        if(t == 1){
            int l, r, x;
            l = QR[j].first.second;
            r = QR[j].second.first;
            x = QR[j].second.second;
            l--; r--;
            for (int i = l; i <= r ; ++i) {
                a[i] = x;
            }
        }else{
            int v;
            v = QR[j].first.second;
            v--;
            e.clear();
            dfs(S);
            for (int i = 0; i < e.size(); ++i) {
                if(e[i]==v){
                    cout << i+1 << '\n';
                    break;
                }
            }
        }
    }
}

void solve2(int q, int S, int n){
    vector<int> idv(n);
    dfs(S);
    for (int i = 0; i < e.size(); ++i) {
        idv[e[i]] = i;
    }
    for(int j = 0; j < q; j++){
        int t;
        t=QR[j].first.first;
        if(t == 1){
            int l, r, x;
            l = QR[j].first.second;
            r = QR[j].second.first;
            x = QR[j].second.second;
            l--; r--;
            for (int i = l; i <= r ; ++i) {
                a[i] = x;
            }
            dfs(S);
            for (int i = 0; i < e.size(); ++i) {
                idv[e[i]] = i;
            }
        }else{
            int v;
            v = QR[j].first.second;
            v--;
            e.clear();
            cout << idv[v]+1 << '\n';
        }
    }
}

void solve3(int q, int S, int n){
    vector<int> idv(n);
    build(1, 0, N);
    int cnt = 0;
    for(int j = 0; j < q; j++){
        int t;
        t=QR[j].first.first;
        if(t == 1){
            int l, r, x;
            l = QR[j].first.second;
            r = QR[j].second.first;
            x = QR[j].second.second;
            l--;
            upd(1, 0, N, l, r, x);

        }else{
            cnt++;
            if(cnt == 1){
                for (int i = 0; i < n; ++i) {
                    a[i] = get(1, 0, N, i);
                }
                dfs(S);
                for (int i = 0; i < e.size(); ++i) {
                    idv[e[i]] = i;
                }
            }
            int v;
            v = QR[j].first.second;
            v--;
            e.clear();
            cout << idv[v]+1 << '\n';
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    g.resize(n);
    memset(a, -1, sizeof(a));
    vector<int> p(n, -1);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        g[i] ={-1, -1};
        if(l!=-1) {
            g[i].first = l;
            p[l] = i;
        }
        if(r!=-1) {
            g[i].second = r;
            p[r] = i;
        }
    }
    int q1c = 0;
    for (int i = 0; i < q; ++i) {
        int x=-1, y=-1, z=-1, w=-1;
        cin >> x;
        if(x==1) {
            cin >> y >> z >> w;
            q1c++;
        }
        else
            cin >> y;
        QR.push_back({{x, y}, {z, w}});
    }
    int S;
    for (int i = 0; i < n; ++i) {
        if(p[i]==-1)
            S = i;
    }
    if(n <= 5000 && q<=5000){
        solve1(q, S);
    }else if(q1c <=10)
        solve2(q, S, n);
    else
        solve3(q, S, n);
}
/*
 5 5
3 4
0 0
5 2
0 0
 0 0
2 2
1 1 3 1
2 5
1 3 3 0
2 3
 */